/*
Based on Schnark's javascript for Reference tooltips
*/
(function($){
var	config = {
		showDelay: 200,
		hideDelay: 200
	};
var hover_cache = {};
if (window.xowa_hover_show_more == null) {
  window.xowa_hover_show = xowa_hover_show;
  window.xowa_hover_show_update = xowa_hover_show_update;
}
function xowa_hover_show(hover_id, hover_html) {
  var hover_itm = hover_cache[hover_id];
  if (!hover_itm) return;
  hover_itm.html = hover_html;
  xowa_hover_show_itm(hover_itm);
}
function xowa_hover_show_update(hover_id, hover_html) {
  $popup = $( "#" + hover_id );
  $popup.html(hover_html);
  var $window = $(window);
	pos = getPos($popup.position().x, 0, $popup.outerWidth(), $popup.outerHeight(), $window.width(), $window.height());
  if (window.xowa.js.mathJax == null)
    window.xowa.js.load_lib(xowa.root_dir + 'bin/any/javascript/xowa/mathjax/xowa_mathjax.js', mathJaxRun); // note that this will only load mathjax if there are math items on the page
  else
    mathJaxRun();
  bind_hover_to($('a', $popup));
	$popup.css({
		left: pos.x,
		top: pos.y,
		maxHeight: $window.height() - 20 //margin, border, padding + noch ein bisschen Sicherheit
	});
}
function xowa_hover_show_itm(hover_itm) {
  var hover_link = hover_itm.link;
  var hover_ev = hover_itm.ev;
  hover_link.prop('title', '');  // if content found, suppress title; otherwise title-tooltip may block part of popup
	data = hover_link.data();
	if (data.willShow) {
		return;
	}
	if (data.willHide) {
		hover_link.data('willHide', false);
		window.clearTimeout(data.hideTimer);
		return;
	}
	if (data.popupVisible) {
		return;
	}
	hover_link.data({
		willShow: true,
		showTimer: window.setTimeout(function () {
			hover_link.data({
				willShow: false,
				popupVisible: true,
				popupRef: reallyShow(hover_itm.id, hover_itm.html, hover_ev.clientX, hover_ev.clientY).hover(
					function () {
						show(hover_link, hover_ev);
					}, function () {
						hide(hover_link);
					})
			});
		}, config.showDelay)
	});
}
var hover_next_id = 1;
function show ($this, ev) {
  var href = $this.attr('href');
  var hover_html = xowa_exec('hover_get_sync', hover_next_id, href);
  if (!hover_html) return;  // hover_itm_id is null; occurs for xowa-cmd
  var hover_id = 'hover_' + (hover_next_id++).toString();
  var hover_itm = {
    id            : hover_id,
    href          : href,
    link          : $this,
    ev            : ev,
  };
  hover_itm.html = hover_html;
  hover_cache[hover_id] = hover_itm;
  xowa_hover_show_itm(hover_itm);
}
/*
function show ($this, ev) {
  var href = $this.attr('href');
  var hover_itm_id = xowa_exec('hover_get_async_bgn', 'xowa_hover_show', href);
  if (!hover_itm_id) return;  // hover_itm_id is null; occurs for xowa-cmd
  hover_itm = {
    id            : hover_itm_id,
    href          : href,
    link          : $this,
    ev            : ev,
  };
  hover_cache[hover_itm_id] = hover_itm;
}
*/
function getPos (x, y, w, h, W, H) {
	var d = 7;  // increase distance to prevent hovercard from overlapping with link
	if (x + d + w > W) {
		x = W - w - 2;
		d = 20;
		if (x < 0) {
			x = 0;
		}
	} else {
		x = x + d;
	}
	if (y < h + d) {
		if (y + d + h < H) {
			y = y + d;
		} else {
			y = 0;
		}
	} else {
		y = y - h - d;
	}
	return {x: x, y: y};
}
function mathJaxRun() {
  window.xowa.js.mathJax.run();
}
function reallyShow (hover_id, $extract, x, y) {
	var $window = $(window), $popup, pos;
	$popup = $('<div>').attr('id', hover_id).addClass('xowa_hovercard').append($extract).appendTo($('#mw-content-text'));
	pos = getPos(x, y, $popup.outerWidth(), $popup.outerHeight(), $window.width(), $window.height());
  if (window.xowa.js.mathJax == null)
    window.xowa.js.load_lib(xowa.root_dir + 'bin/any/javascript/xowa/mathjax/xowa_mathjax.js', mathJaxRun); // note that this will only load mathjax if there are math items on the page
  else
    mathJaxRun();
  bind_hover_to($('a', $popup));
	return $popup.css({
		left: pos.x,
		top: pos.y,
		maxHeight: $window.height() - 20 //margin, border, padding + noch ein bisschen Sicherheit
	}).hide().fadeIn('fast');
}
function hide ($this) {
	var data = $this.data();
	if (data.willHide) {
		return;
	}
	if (data.willShow) {
		$this.data('willShow', false);
		window.clearTimeout(data.showTimer);
		return;
	}
	if (!data.popupVisible) {
		return;
	}
	$this.data({
		willHide: true,
		hideTimer: window.setTimeout(function () {
			$this.data({
				willHide: false,
				popupVisible: false
			});
			reallyHide(data.popupRef);
		}, config.hideDelay)
	});
}

function reallyHide ($popup) {
	$popup.fadeOut('fast', function () {
		if ($popup.find('a').length) {
			$popup.detach();
		} else {
			$popup.remove();
		}
	});
}

function bind_hover_to_doc() {
  bind_hover_to($('a'));
}
function bind_hover_to(elems) {
	elems.hover(
		function (e) {
			show($(this), e);
		}, function () {
			hide($(this));
		});
}

$(bind_hover_to_doc);

})(jQuery);
