/*
Based on Schnark's javascript for Reference tooltips
*/
(function($){
var	cfg = {
		showDelay           : xowa.cfg.get('popups-win-show_delay'),
		hideDelay           : xowa.cfg.get('popups-win-hide_delay'),
		max_w               : xowa.cfg.get('popups-win-max_w'),
		max_h               : xowa.cfg.get('popups-win-max_h'),
		show_all_max_w      : xowa.cfg.get('popups-win-show_all_max_w'),
		bind_focus_blur     : xowa.cfg.get('popups-win-bind_focus_blur'),
	};
if (window.xowa_popups_show_update == null) {
  window.xowa_popups_show_update = xowa_popups_show_update;
}
var popup_cache = {};
var popup_next_id = 1;
var protocol_pattern = /^((http|https|ftp|xowa-cmd):\/\/)/;
function xowa_popups_show_update(mode, href, html) {
  var popup_itm = popup_cache[href];
  if (!popup_itm) return; // shouldn't happen
  var $popup = $("#" + popup_itm.id);
  $popup.html(html);
  popup_itm.html = html;
  var popup_x = $popup.offset().left - $(window).scrollLeft();
  var popup_max_w = cfg.max_w;
  if (mode == 'all' && cfg.show_all_max_w != -1) {
    popup_max_w = cfg.show_all_max_w;
    var window_width = $(window).width();
    if (popup_x + popup_max_w > window_width)
      popup_x = window_width - popup_max_w;
    if (popup_x < 0) popup_x = 0;
  }
  show_popup($popup, popup_x, 0, popup_max_w);  // set y to 0; needed for show all;
}
function show_focus ($this) {
  var ev = {
    clientX : $this.offset().left - $(window).scrollLeft(),
    clientY : $this.offset().top - $(window).scrollTop(),
  }
  show($this, ev);
}

function show ($this, ev) {
  var href = $this.attr('href');
  if (href && href.length > 0 && href[0] == '#') return;
  if (protocol_pattern.test(href)) return; // ignore hrefs with absolute protocol of "http:", etc. which won't point to XOWA content
  var popup_itm = popup_cache[href];
  if (!popup_itm) {
    popup_itm = {
      href          : href,
    };
    popup_cache[href] = popup_itm;
  }
	data = $this.data();
	if (data.willShow) {
		return;
	}
	if (data.willHide) {
		$this.data('willHide', false);
		window.clearTimeout(data.hideTimer);
		return;
	}
	if (data.popupVisible) {
		return;
	}
	$this.data({
		willShow: true,
		showTimer: window.setTimeout(function () {
			$this.data({
				willShow: false,
				popupVisible: true,
				popupRef: show_init($this, popup_itm, ev.clientX, ev.clientY).hover(
					function () {
						show($this, ev);
					}, function () {
						hide($this);
					})
			});
		}, cfg.showDelay)
	});
}
function show_init (elem, popup_itm, anchor_x, anchor_y) {
  if (!popup_itm.html) {
    var html = xowa_exec('popups_get_html', popup_next_id, popup_itm.href);
    if (!html) return;  // html is null; occurs for protocols such as http: and xowa-cmd:
    popup_itm.html = html;
  }
  elem.prop('title', '');  // if content found, suppress title; otherwise title-tooltip may block part of popup
  var popup_id = 'popup_' + (popup_next_id++).toString();
  popup_itm.id = popup_id;
	var $popup = $('<div>').attr('id', popup_id).addClass('xowa_popup').append(popup_itm.html).appendTo($('#mw-content-text'));
  return show_popup($popup, anchor_x, anchor_y, cfg.max_w);
}
function show_popup($popup, anchor_x, anchor_y, popup_max_w) {
	var $window = $(window);
	var popup_pos = calc_popup_pos(anchor_x, anchor_y, $popup.outerWidth(), $popup.outerHeight(), $window.width(), $window.height());  
  if (window.xowa.js.mathJax == null)
    window.xowa.js.load_lib(xowa.root_dir + 'bin/any/javascript/xowa/mathjax/xowa_mathjax.js', xowa_mathjax_run); // note that this will only load mathjax if math items are on page
  else
    xowa_mathjax_run();
  bind_hover_to($('a', $popup));  
	$popup.css({
		left: popup_pos.x,
		top : popup_pos.y,
	});
  if (popup_max_w > 0)
    $popup.css({maxWidth: popup_max_w});
    $popup.css({maxWidth  : cfg.max_w});
  var max_h = $window.height() - 20; //margin, border, padding + noch ein bisschen Sicherheit
  if (cfg.max_h > 0 && cfg.max_h < max_h)
    max_h = cfg.max_h;
  $popup.css({maxHeight: max_h});
  return $popup.hide().fadeIn('fast');
}
function xowa_mathjax_run() { // NOTE: need indirection via function else null ref when window.xowa.js.mathJax == null
  window.xowa.js.mathJax.run();
}
function calc_popup_pos (x, y, w, h, W, H) {
	var d = 7;  // increase distance to prevent popup from overlapping with link
	if (x + d + w > W) {
		x = W - w - 2;
		d = 20;
		if (x < 0) {
			x = 0;
		}
	} else {
		x = x + d;
	}
	if (y < h + d) {
		if (y + d + h < H) {
			y = y + d;
		} else {
			y = 0;
		}
	} else {
		y = y - h - d;
	}
	return {x: x, y: y};
}
function hide ($this) {
	var data = $this.data();
	if (data.willHide) {
		return;
	}
	if (data.willShow) {
		$this.data('willShow', false);
		window.clearTimeout(data.showTimer);
		return;
	}
	if (!data.popupVisible) {
		return;
	}
	$this.data({
		willHide: true,
		hideTimer: window.setTimeout(function () {
			$this.data({
				willHide: false,
				popupVisible: false
			});
			reallyHide(data.popupRef);
		}, cfg.hideDelay)
	});
}

function reallyHide ($popup) {
	$popup.fadeOut('fast', function () {
		if ($popup.find('a').length) {
			$popup.detach();
		} else {
			$popup.remove();
		}
	});
}

function bind_hover_to_doc() {
  bind_hover_to($('a'));
}
function bind_hover_to(elems) {
	elems.hover(
		function (e) {
			show($(this), e);
		}, function () {
			hide($(this));
		});
  if (cfg.bind_focus_blur) {
    elems.focus(
      function (e) {
        show_focus($(this), e);
      }
    );
    elems.blur(
      function (e) {
        hide($(this), e);
      }
    );
  }
}

$(bind_hover_to_doc);

})(jQuery);
